import json, telnetlib, urllib, urllib2, cookielib

JSON_MANAGER_URL = 'http://127.0.0.1:8088/mjson'
TELNET_MANAGER_HOST = '127.0.0.1'
TELNET_MANAGER_PORT = 5038

USERNAME='101'
SECRET='1423'

tests = [
	{'action': 'login', 'username': USERNAME, 'secret': SECRET}, # This always first.
	{'action': 'Ping'},
	{'action': 'Status'},
	{'action': 'CoreShowChannels'},
	{'action': 'ListCommands'},
]

cj = cookielib.LWPCookieJar()
opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
urllib2.install_opener(opener)

has_errors = False

try:
	tn = telnetlib.Telnet(TELNET_MANAGER_HOST, TELNET_MANAGER_PORT)
	
	if 'Asterisk Call Manager' not in tn.read_until('\r\n'):
		raise Exception('Is it really the Asterisk Manager?')
	
	for test in tests:
		if not test['action']:
			raise Exception('Test without action', test)
		
		url = JSON_MANAGER_URL + '?' + urllib.urlencode(test)
		print('\n' + url)
		
		json_response = json.load(urllib2.urlopen(url))
		
		request = 'action: %s\r\n' % test['action']
		del test['action']
		for args in test.iteritems():
			request += '%s: %s\r\n' % args
		request += '\r\n'
		tn.write(request)
		
		for item in json_response:
			telnet_response = tn.read_until('\r\n\r\n')[:-4]
			for line in telnet_response.split('\r\n'):
				key,telnet_value = line.split(': ', 1)
				json_value = item[key.lower()];
				equal = telnet_value == json_value
				if equal:
					print('[ OK ] %s: %s' % (key, telnet_value))
				else:
					has_errors = True
					print('[ !! ] %s: "%s" != "%s"' % (key, telnet_value, json_value))
	
	if has_errors:
		print('\nDone, with errors.')
	else:
		print('\nDone, all clear.')
	
finally:
	tn.close()